## cctbx 2021.12+ds1

=== mmtbx/probe/CMakeLists.txt ===
# SCons is the build system that is used to build CCTBX projects.
# This CMakeLists.txt and the associated files in cmake/ were used before CCTBX native
# integration and during development to enable running the C++ code within the
# Visual Studio IDE for rapid debugging.

cmake_minimum_required(VERSION 3.10.0)
project(probe)

if (WIN32)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif ()

# Find the packages we require and can use
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")
find_package(CCTBX REQUIRED)
find_package(Boost REQUIRED)

set(USE_PYTHON TRUE)
FIND_PACKAGE(PythonInterp)
if (PYTHONINTERP_FOUND)
  if (UNIX AND NOT APPLE)
    if (PYTHON_VERSION_MAJOR EQUAL 3)
        FIND_PACKAGE(Boost COMPONENTS python${PYTHON_VERSION_SUFFIX})
        FIND_PACKAGE(PythonInterp 3)
        FIND_PACKAGE(PythonLibs 3 REQUIRED)
    else()
        FIND_PACKAGE(Boost COMPONENTS python)
        FIND_PACKAGE(PythonInterp)
        FIND_PACKAGE(PythonLibs REQUIRED)
    endif()
  else()
    if (PYTHON_VERSION_MAJOR EQUAL 3)
        FIND_PACKAGE(Boost COMPONENTS python${PYTHON_VERSION_MAJOR}${PYTHON_VERSION_MINOR})
        FIND_PACKAGE(PythonInterp 3)
        FIND_PACKAGE(PythonLibs 3 REQUIRED)
    else()
        FIND_PACKAGE(Boost COMPONENTS python${PYTHON_VERSION_MAJOR}${PYTHON_VERSION_MINOR})
        FIND_PACKAGE(PythonInterp)
        FIND_PACKAGE(PythonLibs REQUIRED)
    endif()
  endif()
else()
    set(USE_PYTHON FALSE)
    message("Python not found")
endif()
if (NOT Boost_FOUND)
    set(USE_PYTHON FALSE)
endif()

set(probe_SOURCES
  Scoring.cpp
  DotSpheres.cpp
  SpatialQuery.cpp
)

set(probe_HEADERS
  Common.h
  Scoring.h
  DotSpheres.h
  SpatialQuery.h
)

add_library(probeLib ${probe_SOURCES} ${probe_HEADERS})
target_include_directories(probeLib PUBLIC SYSTEM
  ${CCTBX_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIR})
target_link_libraries(probeLib
    PUBLIC
    ${CCTBX_LIBRARIES}
    ${Boost_LIBRARIES}
    ${PYTHON_LIBRARIES}
)
if (NOT WIN32)
  target_link_libraries(probeLib PUBLIC m)
endif()

add_executable(tst_probe tst_probe.cpp)
target_link_libraries(tst_probe probeLib)
if (NOT WIN32)
  target_link_libraries(tst_probe m)
endif()

if (USE_PYTHON)
  message(STATUS "Building Boost.Python library")
  message(STATUS "PYTHON_LIBRARIES = ${PYTHON_LIBRARIES}")
  message(STATUS "PYTHON_EXECUTABLE = ${PYTHON_EXECUTABLE}")
  message(STATUS "PYTHON_INCLUDE_DIRS = ${PYTHON_INCLUDE_DIRS}")
  message(STATUS "Boost_LIBRARIES = ${Boost_LIBRARIES}")
  include_directories(../libpdb ../toolclasses ${Boost_INCLUDE_DIRS} ${PYTHON_INCLUDE_DIRS})
  # Note: To make this work on Windows, you need to copy the boost_python*.dll file into the
  # executable directory to avoid an error about "DLL load failed: The specified module could not be found"
  PYTHON_ADD_MODULE(mmtbx_probe_ext boost_python/probe_bpl.cpp)
  target_link_libraries(mmtbx_probe_ext PRIVATE probeLib)

  add_custom_command(
    TARGET mmtbx_probe_ext POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy
      ${CMAKE_SOURCE_DIR}/tst_probe.py
      ${CMAKE_CURRENT_BINARY_DIR}
  )
endif()

## cctbx 2021.12%2Bds1

=== debian/changelog ===
cctbx (2021.12+ds1-4ubuntu1) jammy; urgency=medium

  * Re-enable build on riscv64, which was silently dropped

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 31 Mar 2022 07:21:53 +0000

cctbx (2021.12+ds1-4) unstable; urgency=medium

  * Use sysconfig to obtain path to boost_python to avoid needing the
    python version in the system_libs patch in boost_adaptbx/SConsscript
    (Closes: #1008520)

 -- Neil Williams <codehelp@debian.org>  Tue, 29 Mar 2022 10:16:15 +0100

cctbx (2021.12+ds1-3) unstable; urgency=medium

  * Apply patch from reproducible builds: Timestamps embedded in
    boost_python_meta_ext.so.0.0.1 (Closes: #1006252)

 -- Neil Williams <codehelp@debian.org>  Thu, 03 Mar 2022 09:36:43 +0000

cctbx (2021.12+ds1-2) unstable; urgency=medium

  * Source only upload

 -- Neil Williams <codehelp@debian.org>  Sun, 13 Feb 2022 08:27:32 +0000

cctbx (2021.12+ds1-1) unstable; urgency=medium

  * Add missing scitbx header files
  * New upstream release.

 -- Neil Williams <codehelp@debian.org>  Thu, 27 Jan 2022 14:13:37 +0000

cctbx (2021.8+ds2-1) unstable; urgency=low

  * Initial release (Closes: #679905)

 -- Neil Williams <codehelp@debian.org>  Thu, 09 Dec 2021 09:56:20 +0000

=== debian/control ===
Source: cctbx
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Neil Williams <codehelp@debian.org>,
 Picca Frédéric-Emmanuel <picca@debian.org>,
 Radostan Riedel <raybuntu@googlemail.com>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 dh-python,
 jq,
 python3-all-dev:any,
 scons,
 liblz4-dev,
 libexpat1-dev,
 libfftw3-dev,
 libcbf-dev,
 libann-dev,
 libclipper-dev,
 libantlr3c-dev,
 libboost-dev,
 libboost-python-dev,
 libboost-thread-dev,
 libboost-numpy-dev,
 libtool,
 libeigen3-dev,
 python3-numpy,
 python3-setuptools,
 python3-matplotlib,
 python3-biopython,
 python3-psutil,
 python3-msgpack,
 python3-six,
 python3-future,
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/cctbx
Vcs-Git: https://salsa.debian.org/science-team/cctbx.git
Homepage: https://github.com/cctbx/cctbx_project
Rules-Requires-Root: no

Package: libcctbx0
Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el s390x riscv64
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Computational Crystallography Toolbox
 Computational Crystallography Toolbox contains following modules:
    boost_adaptbx: wrappers for Boost functionality in CCTBX
    cctbx: Libraries for general crystallographic applications,
      useful for both small-molecule and macro-molecular
      crystallography.
    crys3d: Modules for the display of molecules, electron density,
      and reciprocal space data.
    fable: Fortran EMulation library  for porting Fortran77 to C++.
    iotbx: Working with common crystallographic file formats.
    omptbx: OpenMP interface.
    scitbx: General scientific calculations. his includes a family of
      high-level C++ array types, a fast Fourier transform library,
      and a C++ port of the popular L-BFGS quasi-Newton minimizer.
    smtbx: Small-Molecule crystallography.
    wxtbx: wxPython controls used in the Phenix GUI and various
        utilities

Package: libcctbx-dev
Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el s390x riscv64
Depends: libcctbx0 (= ${binary:Version}), ${misc:Depends},
Section: devel
Description: Computational Crystallography Toolbox (headers)
 Header files for packages using cctbx shared libraries supporting
 the cctbx, cbflib, scitbx, crys3d, libtbx, iotbx, wxtbx and smtbx
 modules.

Package: python3-cctbx
Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el s390x riscv64
Section: python
Depends:
 libcctbx0 (= ${binary:Version}),
 ca-certificates,
 ${python3:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Description: Python Toolbox for crystallography
 Python Modules for crystallographic applications, useful for both
 small-molecule and macro-molecular crystallography and modules for
 general scientific calculations.

## cctbx 2021.12+ds1

=== debian/changelog ===
cctbx (2021.12+ds1-7) unstable; urgency=medium

  * Added the boost_adaptbx module for dxtbx
  * Added d/libcctbx-dev.links
  * d/t/control: run test only with python 3.10 for now
  * d/setup.py: do not instal deprecated module boost (Closes: #1014941)
  * s/setup.py: use the right wx -> wxPython dependency
  * d/rules: Install all headers using rsync

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 15 Jul 2022 16:29:26 +0200

cctbx (2021.12+ds1-6) unstable; urgency=medium

  * d/rules: make the build verbose
  * d/p/adding-setup.py.patch: removed setup.py is now in the debian directory
  * d/setup.py: a simpler version in order to install all python modules.
  * d/rules: use pybuild to install the generated files (scripts, librariers,
    extensions)
  * d/control: Added B-D python3-wxgtk4.0
  * d/rules: install the /usr/share/cctbx files
  * d/rules: use nproc instread of dh_assistant for backport
  * d/t/control: Adding first autopkgtest

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 13 Jul 2022 15:01:47 +0200

cctbx (2021.12+ds1-5) unstable; urgency=medium

  * Team upload.
  * Enable riscv64 build (Closes: #1009191).
  * Trim trailing whitespace.

 -- Andrius Merkys <merkys@debian.org>  Mon, 02 May 2022 01:51:34 -0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: cctbx
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders:
  Neil Williams <codehelp@debian.org>,
  Picca Frédéric-Emmanuel <picca@debian.org>,
@@ -12,29 +11,31 @@
  dh-exec,
  dh-python,
  jq,
- python3-all-dev:any,
- scons,
- liblz4-dev,
+ libann-dev,
+ libantlr3c-dev,
+ libboost-dev,
+ libboost-numpy-dev,
+ libboost-python-dev,
+ libboost-thread-dev,
+ libcbf-dev,
+ libclipper-dev,
+ libeigen3-dev,
  libexpat1-dev,
  libfftw3-dev,
- libcbf-dev,
- libann-dev,
- libclipper-dev,
- libantlr3c-dev,
- libboost-dev,
- libboost-python-dev,
- libboost-thread-dev,
- libboost-numpy-dev,
+ liblz4-dev,
  libtool,
- libeigen3-dev,
+ python3-all-dev:any,
+ python3-biopython,
+ python3-future,
+ python3-matplotlib,
+ python3-msgpack,
  python3-numpy,
+ python3-psutil,
  python3-setuptools,
- python3-matplotlib,
- python3-biopython,
- python3-psutil,
- python3-msgpack,
  python3-six,
- python3-future,
+ python3-wxgtk4.0,
+ rsync,
+ scons,
 Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/science-team/cctbx
 Vcs-Git: https://salsa.debian.org/science-team/cctbx.git
@@ -42,10 +43,11 @@
 Rules-Requires-Root: no
 
 Package: libcctbx0
-Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el s390x riscv64
+Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el riscv64 s390x
 Section: libs
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Computational Crystallography Toolbox
  Computational Crystallography Toolbox contains following modules:
     boost_adaptbx: wrappers for Boost functionality in CCTBX
@@ -65,8 +67,10 @@
         utilities
 
 Package: libcctbx-dev
-Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el s390x riscv64
-Depends: libcctbx0 (= ${binary:Version}), ${misc:Depends},
+Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el riscv64 s390x
+Depends:
+ libcctbx0 (= ${binary:Version}),
+ ${misc:Depends},
 Section: devel
 Description: Computational Crystallography Toolbox (headers)
  Header files for packages using cctbx shared libraries supporting
@@ -74,13 +78,13 @@
  modules.
 
 Package: python3-cctbx
-Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el s390x riscv64
+Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el riscv64 s390x
 Section: python
 Depends:
+ ca-certificates,
  libcctbx0 (= ${binary:Version}),
- ca-certificates,
+ ${misc:Depends},
  ${python3:Depends},
- ${misc:Depends},
  ${shlibs:Depends},
 Description: Python Toolbox for crystallography
  Python Modules for crystallographic applications, useful for both

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# parallel support
#NPROC ?= $(shell dh_assistant which-build-system| jq .parallel)
NPROC ?= $(shell nproc)  # for backport

# Multiarch
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# so version number managed by Debian
SONAME=0
SOVERSION=0.0.1

MODULES         = boost_adaptbx cctbx scitbx crys3d libtbx iotbx wxtbx smtbx

embed:
	# a bunche of modules are missing in the original git repository, so embed them for now
	# annlib_adaptbx
	git clone https://github.com/cctbx/annlib_adaptbx annlib_adaptbx
	rm -rf annlib_adaptbx/.git*
%:
	dh $@ --with python3 --buildsystem=pybuild

annlib_adaptbx:
	cp -r debian/annlib_adaptbx annlib_adaptbx

setup.py : debian/setup.py
	cp -f $< $@

override_dh_auto_clean: setup.py
	dh_auto_clean
	find . -name __pycache__ -type d -exec rm -rf {} \;

override_dh_auto_configure: setup.py annlib_adaptbx
	dh_auto_configure
	dh_auto_configure -- -s custom --configure-args="mkdir -p {build_dir}_ && cd {build_dir}_ && {interpreter} $(CURDIR)/libtbx/configure.py --build=debug --use_environment_flags $(MODULES)"

override_dh_auto_build: setup.py annlib_adaptbx
	# build the python modules
	dh_auto_build

	# build the extensions and the libraries
	dh_auto_build -- -s custom --build-args="cd {build_dir}_ && ./bin/libtbx.scons -j $(NPROC)"
	iconv -f ISO-8859-1 -t UTF-8 cctbx/eltbx/covalent_radii.h > covalent_radii.h
	mv covalent_radii.h cctbx/eltbx/covalent_radii.h

	# move all extensions into the python build directory
	dh_auto_build -- -s custom --build-args="mv {build_dir}_/lib/*_ext* {build_dir}"

override_dh_auto_install: setup.py annlib_adaptbx
	dh_auto_install

	# install all the scripts
	dh_auto_install -- -s custom --install-args="mkdir -p {destdir}/usr/bin \
		; cp -f {build_dir}_/bin/* {destdir}/usr/bin"

	# install the libraries with soversion numbers
	dh_auto_install -- -s custom --install-args="mkdir -p {destdir}/usr/lib/$(DEB_HOST_MULTIARCH) \
		; cp -f {build_dir}_/lib/*.so {destdir}/usr/lib/${DEB_HOST_MULTIARCH}"

	cd $(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH} && \
	for f in *.so; do \
		mv $$f $$f.$(SOVERSION);\
		ln -s $$f.$(SOVERSION) $$f.$(SONAME); \
		ln -s $$f.$(SONAME) $$f; \
	done

	# install all the headers
	mkdir -p $(CURDIR)/debian/tmp/usr/include/cctbx/
	rsync -ar --prune-empty-dirs --exclude=debian --include=*/ --include="*.h" --include="*.hpp" --exclude="*" $(CURDIR)/ $(CURDIR)/debian/tmp/usr/include/cctbx/

	# install the generated headers
	dh_auto_install -- -s custom --install-args="rsync -ar --prune-empty-dirs --include=*/ --include='*.h' --include='*.hpp' --exclude='*' {build_dir}_/include/ {destdir}/usr/include/cctbx/"

	# dh_auto_install -- -s custom --install-args="mkdir -p {destdir}/usr/include/cctbx/scitbx/array_family \
        #         ; cp -f {build_dir}_/include/scitbx/array_family/small_reductions.h {destdir}/usr/include/cctbx/scitbx/array_family \
        #         ; cp -f {build_dir}_/include/scitbx/array_family/small_algebra.h  {destdir}/usr/include/cctbx/scitbx/array_family \
        #         ; cp -f {build_dir}_/include/scitbx/array_family/operator_traits_builtin.h {destdir}/usr/include/cctbx/scitbx/array_family \
        #         ; cp -f {build_dir}_/include/scitbx/array_family/tiny_reductions.h {destdir}/usr/include/cctbx/scitbx/array_family \
	# 	; mkdir -p {destdir}/usr/include/cctbx/scitbx/array_family/detail \
        #         ; cp -f {build_dir}_/include/scitbx/array_family/detail/operator_functors.h {destdir}/usr/include/cctbx/scitbx/array_family/detail \
        #         ; cp -f {build_dir}_/include/scitbx/array_family/detail/std_imports.h {destdir}/usr/include/cctbx/scitbx/array_family/detail"

	# install /usr/share/cctbx files
	dh_auto_install -- -s custom --install-args="mkdir -p {destdir}/usr/share/cctbx \
                ; cp -f {build_dir}_/libtbx_env {destdir}/usr/share/cctbx"


override_dh_auto_test: setup.py annlib_adaptbx
	# DOES NOT WORK, source code must be modified in order to find the expected
	# /usr/share/cctbx libtbx_env file during the build
	#dh_auto_test -- -s custom --test-args="LD_LIBRARY_PATH={build_dir}_/lib dh_auto_test"

.PHONY: embed

=== debian/tests/control ===
Test-Command: set -efu
 ; cp -r . "$AUTOPKGTEST_TMP"
 ; for py in $(py3versions -r 3.10 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py /usr/lib/python3/dist-packages/libtbx/command_line/run_tests_parallel.py  module=cctbx
 ; done
Depends:
 python3-all,
 python3-cctbx,
Restrictions: allow-stderr, skip-not-installable

## cctbx 2022.7+ds2

=== debian/changelog ===
cctbx (2022.7+ds2-1build2) lunar; urgency=medium

  * No-change rebuild with Python 3.11 as supported

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 03 Nov 2022 18:47:03 +0000

cctbx (2022.7+ds2-1build1) kinetic; urgency=medium

  * No-change rebuild to pick up fixed libboost-python dependencies

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 03 Sep 2022 13:06:01 +0000

cctbx (2022.7+ds2-1) unstable; urgency=medium

  * New upstream version 2022.7+ds2
  * More modules activated
    - cbflib_adaptbx
  * d/p/refresh the patch series
  * d/control: Added B-D python3-scipy to fix the autopkgtest
  * d/p/0010-fix-cbflib_adaptbx-compilation-with-the-system-cbfli.patch
    - Modity to avoid building the local cbf and pycbf binaries
    - build a cbf-private shared library with the extra cbf files

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 10 Aug 2022 16:15:42 +0200

cctbx (2021.12+ds1-8) unstable; urgency=medium

  * More modules activated
    - annlib_adaptbx
    - ccp4io
    - ccp4io_adaptbx
    - fable
    - mmtbx
  * Added missing Python extensions
    - iotbx_cif_ext
    - iotbx_mtz_ext
  * d/t/control: start autopkgtest from an empty directory
  * d/rules: activated --enable_cxx11
  * d/rules: install libtbx_env under /usr/lib/cctbx/pythonX.Y
  * Bug fix: "FTBFS: dpkg-buildpackage: error: dpkg-source -b . subprocess
    returned exit status 2", thanks to Lucas Nussbaum (Closes: #1016324).
  * Bug fix: "autopkgtest failure: Please run this program in an empty
    directory.", thanks to Paul Gevers (Closes: #1016499).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 09 Aug 2022 17:44:07 +0200

=== debian/control ===
--- 
+++ 
@@ -23,6 +23,7 @@
  libexpat1-dev,
  libfftw3-dev,
  liblz4-dev,
+ libssm-dev,
  libtool,
  python3-all-dev:any,
  python3-biopython,
@@ -31,7 +32,9 @@
  python3-msgpack,
  python3-numpy,
  python3-psutil,
+ python3-pytest <!nocheck>,
  python3-setuptools,
+ python3-scipy,
  python3-six,
  python3-wxgtk4.0,
  rsync,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# parallel support
#NPROC ?= $(shell dh_assistant which-build-system| jq .parallel)
NPROC ?= $(shell nproc)  # for backport

MODULES         = annlib_adaptbx boost_adaptbx cbflib_adaptbx ccp4io_adaptbx cctbx cma_es crys3d fable iotbx libtbx mmtbx scitbx smtbx tbxx wxtbx
MODULES_TODO    = glxtbx rstbx spotfinder
MODULES_FAKE    = ccp4io

%:
	dh $@ --with python3 --buildsystem=pybuild

annlib_adaptbx:
	cp -r debian/annlib_adaptbx annlib_adaptbx

ccp4io_adaptbx:
	cp -r debian/ccp4io_adaptbx ccp4io_adaptbx
	mkdir ccp4io

setup.py : debian/setup.py
	cp -f $< $@

override_dh_auto_clean: setup.py annlib_adaptbx ccp4io_adaptbx
	dh_auto_clean
	find . -name __pycache__ -type d -exec rm -rf {} \;
	rm -f setup.py
	rm -rf annlib_adaptbx
	rm -rf ccp4io ccp4io_adaptbx

override_dh_auto_configure: setup.py annlib_adaptbx ccp4io_adaptbx
	dh_auto_configure
	dh_auto_configure -- -s custom --configure-args="mkdir -p {build_dir}_ && cd {build_dir}_ \
		&& {interpreter} $(CURDIR)/libtbx/configure.py --build=debug --use_environment_flags --enable_cxx11 $(MODULES) $(MODULES_FAKE)"

override_dh_auto_build: setup.py annlib_adaptbx ccp4io_adaptbx
	# build the python modules
	dh_auto_build

	# build the extensions and the libraries
	dh_auto_build -- -s custom --build-args="cd {build_dir}_ && ./bin/libtbx.scons -j $(NPROC)"
	iconv -f ISO-8859-1 -t UTF-8 cctbx/eltbx/covalent_radii.h > covalent_radii.h
	mv covalent_radii.h cctbx/eltbx/covalent_radii.h

	# cp all extensions into the python build directory
	dh_auto_build -- -s custom --build-args="cp -f {build_dir}_/lib/*_ext.so {build_dir}"

override_dh_auto_install: setup.py annlib_adaptbx ccp4io_adaptbx
	dh_auto_install

	# specific installation from the cctbx build directory
	dh_auto_install -- -s custom --install-args="debian/install-cctbx.sh -- --pyver={version} --srcdir=$(CURDIR) --builddir={build_dir}_ --modules='$(MODULES)'"

override_dh_link:
	dh_auto_build -- -s custom --build-args="dh_link -p libcctbx-dev usr/include/cctbx usr/lib/cctbx/python{version}/include"

override_dh_auto_test:
	# DOES NOT WORK, source code must be modified in order to find the expected
	# /usr/share/cctbx libtbx_env file during the build process

# target used to trace the embeded git repository used to build cctbx
# a bunche of modules are missing in the original git repository, so embed them for now
embed:
	# annlib_adaptbx
	-git clone http://github.com/cctbx/annlib_adaptbx annlib_adaptbx
	rm -rf annlib_adaptbx/.git*

	# cpp4io_adaptbx
	-git clone http://github.com/cctbx/ccp4io_adaptbx ccp4io_adaptbx
	rm -rf ccp4io_adaptbx/.git*


.PHONY: embed

=== debian/tests/control ===
Test-Command: set -efu
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py /usr/lib/python3/dist-packages/libtbx/command_line/run_tests_parallel.py module=annlib_adaptbx module=boost_adaptbx module=cctbx module=cma_es module=fable module=iotbx module=libtbx module=scitbx module=smtbx nproc=$(nproc)
# module=cbflib_adaptbx module=glxtbx module=rstbx module=spotfinder
 ; done
Depends:
 python3-all,
 python3-cctbx,
 python3-pytest,
Restrictions: allow-stderr, skip-not-installable

## cctbx 2022.9%2Bds2%2B~3.11.2%2Bds1

=== debian/control ===
Source: cctbx
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Neil Williams <codehelp@debian.org>,
 Picca Frédéric-Emmanuel <picca@debian.org>,
 Radostan Riedel <raybuntu@googlemail.com>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 dh-python,
 dh-sequence-numpy3,
 dh-sequence-python3,
 jq,
 libann-cctbx-dev (>= 1.1.2+doc-9~),
 libantlr3c-dev,
 libboost-dev,
 libboost-numpy-dev,
 libboost-python-dev,
 libboost-thread-dev,
 libcbf-dev (>= 0.9.7+dfsg1-2~),
 libclipper-dev,
 libeigen3-dev,
 libexpat1-dev,
 libfftw3-dev,
 libgl-dev,
 libglu1-mesa-dev,
 libhdf5-dev,
 liblz4-dev,
 libssm-dev,
 libtiff-dev,
 libtool,
 pybind11-dev,
 python3-all-dev:any,
 python3-biopython,
 python3-future,
 python3-h5py (>= 3) <!nocheck>,
 python3-matplotlib,
 python3-mrcfile,
 python3-msgpack,
 python3-numpy,
 python3-pint,
 python3-pip,
 python3-procrunner,
 python3-psutil,
 python3-pycbf (>= 0.9.7+dfsg1-2~),
 python3-pymol,
 python3-pytest <!nocheck>,
 python3-requests,
 python3-scipy,
 python3-setuptools,
 python3-six,
 python3-tqdm <!nocheck>,
 python3-wxgtk4.0,
 rsync,
 scons,
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/science-team/cctbx
Vcs-Git: https://salsa.debian.org/science-team/cctbx.git
Homepage: https://github.com/cctbx/cctbx_project
Rules-Requires-Root: no

Package: libcctbx0
Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el riscv64 s390x
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Computational Crystallography Toolbox - runtime libraries
 Computational Crystallography Toolbox contains following modules:
    - annlib_adaptbx:
    - boost_adaptbx: wrappers for Boost functionality in CCTBX
    - cbflib_adaptbx:
    - ccp4io_adaptbx:
    - cctbx: Libraries for general crystallographic applications,
             useful for both small-molecule and macro-molecular
             crystallography.
    - cma_es:
    - crys3d: Modules for the display of molecules, electron density,
              and reciprocal space data.
    - dxtbx: The Diffraction Image Toolbox, a library for handling
             X-ray detector data of arbitrary complexity from a variety
             of standard formats.
    - fable: Fortran EMulation library  for porting Fortran77 to C++.
    - gltbx: Python bindings for OpenGL
    - iotbx: Working with common crystallographic file formats.
    - libtbx: The build system common to all other modules. This includes
              a very thin wrapper around the SCons software construction tool.
              It also contains many useful frameworks and utilities to simplify
              application development, including tools for regression testing,
              parallelization across multiprocessor systems and managed clusters,
              and a flexible, modular configuration syntax called PHIL
              (Python Hierarchial Interface Language) used throughout the CCTBX.
    - mmtbx: Functionality specific to macromolecular crystallography.
             This includes all of the machinery required for setup of
             geometry restraints, bulk solvent correction and scaling,
             analysis of macromolecular diffraction data, calculation of
             weighted map coefficients, and most of the methods implemented
             in phenix.refine. The majority of infrastructure for the MolProbity
             validation server (and Phenix equivalent) is also located here.
    - omptbx: OpenMP interface.
    - rstbx: A reciprocal space toolbox to autoindex small molecule Bragg
             diffraction, given the reciprocal space vectors.
    - scitbx: General scientific calculations. his includes a family of
      high-level C++ array types, a fast Fourier transform library,
      and a C++ port of the popular L-BFGS quasi-Newton minimizer.
    - smtbx: Small-Molecule crystallography.
    - spotfinder:
    - tbxx:
    - wxtbx: wxPython controls used in the Phenix GUI and various
        utilities
 .
 This package provide the cctbx runtime libraries.

Package: libcctbx-dev
Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el riscv64 s390x
Depends:
 libann-cctbx-dev,
 libboost-python-dev,
 libccp4-dev,
 libcctbx0 (= ${binary:Version}),
 ${misc:Depends},
Section: devel
Description: Computational Crystallography Toolbox - headers
 Computational Crystallography Toolbox contains following modules:
    - annlib_adaptbx:
    - boost_adaptbx: wrappers for Boost functionality in CCTBX
    - cbflib_adaptbx:
    - ccp4io_adaptbx:
    - cctbx: Libraries for general crystallographic applications,
             useful for both small-molecule and macro-molecular
             crystallography.
    - cma_es:
    - crys3d: Modules for the display of molecules, electron density,
              and reciprocal space data.
    - dxtbx: The Diffraction Image Toolbox, a library for handling
             X-ray detector data of arbitrary complexity from a variety
             of standard formats.
    - fable: Fortran EMulation library  for porting Fortran77 to C++.
    - gltbx: Python bindings for OpenGL
    - iotbx: Working with common crystallographic file formats.
    - libtbx: The build system common to all other modules. This includes
              a very thin wrapper around the SCons software construction tool.
              It also contains many useful frameworks and utilities to simplify
              application development, including tools for regression testing,
              parallelization across multiprocessor systems and managed clusters,
              and a flexible, modular configuration syntax called PHIL
              (Python Hierarchial Interface Language) used throughout the CCTBX.
    - mmtbx: Functionality specific to macromolecular crystallography.
             This includes all of the machinery required for setup of
             geometry restraints, bulk solvent correction and scaling,
             analysis of macromolecular diffraction data, calculation of
             weighted map coefficients, and most of the methods implemented
             in phenix.refine. The majority of infrastructure for the MolProbity
             validation server (and Phenix equivalent) is also located here.
    - omptbx: OpenMP interface.
    - rstbx: A reciprocal space toolbox to autoindex small molecule Bragg
             diffraction, given the reciprocal space vectors.
    - scitbx: General scientific calculations. his includes a family of
      high-level C++ array types, a fast Fourier transform library,
      and a C++ port of the popular L-BFGS quasi-Newton minimizer.
    - smtbx: Small-Molecule crystallography.
    - spotfinder:
    - tbxx:
    - wxtbx: wxPython controls used in the Phenix GUI and various
        utilities
 .
 This package provide everythings needed to link against the cctbx libraries.

Package: python3-cctbx
Architecture: amd64 arm64 armel armhf i386 ppc64 ppc64el riscv64 s390x
Section: python
Depends:
 ca-certificates,
 libcctbx-dev (= ${binary:Version}),
 libcctbx0 (= ${binary:Version}),
 python3-pycbf (>= 0.9.7+dfsg1-2~),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python Toolbox for crystallography
 Computational Crystallography Toolbox contains following modules:
    - annlib_adaptbx:
    - boost_adaptbx: wrappers for Boost functionality in CCTBX
    - cbflib_adaptbx:
    - ccp4io_adaptbx:
    - cctbx: Libraries for general crystallographic applications,
             useful for both small-molecule and macro-molecular
             crystallography.
    - cma_es:
    - crys3d: Modules for the display of molecules, electron density,
              and reciprocal space data.
    - dxtbx: The Diffraction Image Toolbox, a library for handling
             X-ray detector data of arbitrary complexity from a variety
             of standard formats.
    - fable: Fortran EMulation library  for porting Fortran77 to C++.
    - gltbx: Python bindings for OpenGL
    - iotbx: Working with common crystallographic file formats.
    - libtbx: The build system common to all other modules. This includes
              a very thin wrapper around the SCons software construction tool.
              It also contains many useful frameworks and utilities to simplify
              application development, including tools for regression testing,
              parallelization across multiprocessor systems and managed clusters,
              and a flexible, modular configuration syntax called PHIL
              (Python Hierarchial Interface Language) used throughout the CCTBX.
    - mmtbx: Functionality specific to macromolecular crystallography.
             This includes all of the machinery required for setup of
             geometry restraints, bulk solvent correction and scaling,
             analysis of macromolecular diffraction data, calculation of
             weighted map coefficients, and most of the methods implemented
             in phenix.refine. The majority of infrastructure for the MolProbity
             validation server (and Phenix equivalent) is also located here.
    - omptbx: OpenMP interface.
    - rstbx: A reciprocal space toolbox to autoindex small molecule Bragg
             diffraction, given the reciprocal space vectors.
    - scitbx: General scientific calculations. his includes a family of
      high-level C++ array types, a fast Fourier transform library,
      and a C++ port of the popular L-BFGS quasi-Newton minimizer.
    - smtbx: Small-Molecule crystallography.
    - spotfinder:
    - tbxx:
    - wxtbx: wxPython controls used in the Phenix GUI and various
        utilities
 .
 This package provide a selected collection of python modules from the cctbx project.
